<?php
function bd_cleaner_analisis() {
	global $bdcleaner_conn;

	function marcaTextos( $cadena, $strip = TRUE ) {
		global $bdcleaner_conn;
		if ( $strip == TRUE ) {
			$cadena = strip_tags( $cadena );
		}

		if ( strlen( $cadena ) > 300 ) {
			$cadena = substr( $cadena, 0, 300 )."<strong>...</strong>";
		}

		if ( isset( $_POST['enviar_tablas'] ) && $_POST['parametro'] != "" ) {
			$parametro = htmlspecialchars( $_POST['parametro'] );
			$parametro = $bdcleaner_conn->real_escape_string( $parametro );
		}
		elseif ( isset( $_POST['enviar_tablas'] ) && $_POST['parametro'] == "" ) {
			if ( $_POST['parametro_personalizado'] != "" ) {
				$parametro = htmlspecialchars( $_POST['parametro_personalizado'] );
				$parametro = $bdcleaner_conn->real_escape_string( $parametro );
			}
		}

		$parametro = strtolower( $parametro );
		$cadena = str_replace ( $parametro, '<span style="color: red;">'.$parametro."</span>", $cadena );

		$parametro = ucfirst( $parametro );
		$cadena = str_replace ( $parametro, '<span style="color: red;">'.$parametro."</span>", $cadena );

		$parametro = strtoupper( $parametro );
		$cadena = str_replace ( $parametro, '<span style="color: red;">'.$parametro."</span>", $cadena );

		return $cadena;
	}

	echo '<div class="wrap"><div id="icon-tools" class="icon32"></div>
<h2>Scan and clean your database: <strong>'.DB_NAME.'</strong></h2>';

	if ( empty( $_POST['tabla_nombre'] ) && $_GET['accion'] == "" ) {
	?>
<p><h3>Select tables (max 15).</h3></p>
	<form action="" method="POST">
	<table class="wp-list-table widefat" cellpadding="0" cellspacing="0">
		<thead>
			<tr>
				<th scope="col" id="cb" class="manage-column column-cb check-column">
					<input type="checkbox" />
				</th>
				<th scope="col" id="tabla" class="manage-column column-id">Table</th>
				<th scope="col" id="tamano" class="manage-column column-id">Size</th>
			</tr>
		</thead>
		<tbody>
	<?php
		$tablas = $bdcleaner_conn->query( 'SHOW TABLE STATUS FROM `'.DB_NAME.'`' );

		while( $tabla = $tablas->fetch_assoc() ) {
			$tabla_size = $tabla['Data_length'] + $tabla['Index_length'];
			$tabla_size = $tabla_size / 1024;
			$tabla_size = sprintf( "%0.3f", $tabla_size );

			$every_size = $tabla['Data_length'] + $tabla['Index_length'];
			$every_size = $every_size / 1024;
			$total_size += $every_size;
			?>
			<tr class="alternate">
				<th scope="row" class="check-column">
					<input value="<?php echo $tabla['Name']; ?>" type="checkbox" name="tabla_nombre[]"/>
				</th>
				<td class='id column-id'>
					<div style="margin-top:1px;"><?php echo $tabla['Name']; ?></a></div>
				</td>
				<td class='id column-id'>
					<div style="margin-top:1px;"><?php echo $tabla_size; ?> KB.</div>
				</td>
			</tr>
			<?php
		}
		?>
		</tbody>
	</table>
	<select id="parametro_name" name="parametro" onchange="showHide()">
		<?php
		$search = array(
			"All In One Seo (aioseop)" => "aioseop",
			"All In One Seo (aiosp)" => "aiosp",
			"WordPress SEO By YOAST (yoast)" => "yoast",
			"Disqus Comment System (disqus)" => "disqus",
			"Akismet (akismet)" => "akismet",
			"bbPress (bbpress)" => "bbpress",
			"BuddyPress (buddypress)" => "buddypress",
			);
		foreach ( $search as $nombre_plugin => $key ) {
			echo "<option value='".$key."'>".$nombre_plugin."</option>\n";
		}
		?>
		<option value="" >Other...</option>
	</select>
	<input id="hidden_html" style="display:none;" size="20" type="text" name="parametro_personalizado" placeholder="Custom parameter...">
	<label for="limite">Limit Results: </label><input type="text" name="limite" value="30" size="4" >
	<input type="submit" class="button-primary" value="Scan" name="enviar_tablas">
	</form>
	<?php
	}
	$limite = htmlspecialchars( $_POST['limite'] );
	$limite = $bdcleaner_conn->real_escape_string( $limite );

	// Mostrar Errores
	if ( isset( $_POST['enviar_tablas'] ) && !is_numeric( $_POST['limite'] ) ) {
		echo "<p>El limite debe ser un <strong>número</strong>.</p>";
	}

	if ( isset( $_POST['enviar_tablas'] ) && $_POST['tabla_nombre'] == "" ) {
		echo "<p>Seleccione al menos una Tabla.</p>";
	}

	// Parametro
	if ( isset( $_POST['enviar_tablas'] ) && $_POST['parametro'] != "" ) {
		$parametro = htmlspecialchars( $_POST['parametro'] );
		$parametro = $bdcleaner_conn->real_escape_string( $parametro );
	}
	elseif ( isset( $_POST['enviar_tablas'] ) && $_POST['parametro'] == "" ) {
		if ( $_POST['parametro_personalizado'] != "" ) {
			$parametro = htmlspecialchars( $_POST['parametro_personalizado'] );
			$parametro = $bdcleaner_conn->real_escape_string( $parametro );
		}
		elseif ( $_POST['parametro_personalizado'] == "" ) {
			echo "<p>Inserte una palabra a buscar.</p>";
		}
	}

	if ( isset( $_POST['enviar_tablas'] ) && $_POST['tabla_nombre'] != "" && is_numeric( $_POST['limite'] ) && $parametro != "" ) {

		if ( $_POST['limite'] > 0 ) {
			$_limite = " LIMIT 0 ,".$limite;
		}
		elseif ( $_POST['limite'] == 0 ) {
			$_limite = "";
		}

		$numero_tablas = count( $_POST['tabla_nombre'] );

		if ( $numero_tablas > 15 ) {
			echo "<p>For security, the limit allowed is 15 Tables, <a href='?page=bdcleaner-analisis'>Intentelo nuevamente</a>!.</p>\n";
		}

		elseif ( $numero_tablas <= 15 ) {
			echo "<section><h3><a class='button-secondary' href='?page=bdcleaner-analisis'>Go Back</a></h3></section>";

			foreach ( $_POST['tabla_nombre'] as $indice => $tabla_valor ) {
				$columnas = $bdcleaner_conn->query( "SHOW COLUMNS FROM ".$tabla_valor );

				// Construye la cadena del query con 'OR'
				$cad_or = "SELECT * FROM  `".DB_NAME."`.`".$tabla_valor."` WHERE ";
				$nombre_columna = array();

				// Construye: WHERE columna1 LIKE "%%" OR columna2 LIKE "%%"...
				while ( $fila = $columnas->fetch_array() ) {
					// Genera array de nombres de columna:
					$nombre_columna[] = $fila[0];
					$cad_or .= " `".$tabla_valor."`.`".$fila[0]."` LIKE '%".$parametro."%' OR ";
				}

				// Limpia la cadena y ejecuta
				$cad_or = substr( $cad_or, 0,-3 );
				$execute = $bdcleaner_conn->query( $cad_or.$_limite  );
				$cols_ = $execute->num_rows;

				if ( $cols_ > 0 ) {
					echo "
					<form action='?page=bdcleaner-analisis&accion=do' method='POST'>
					<table class='wp-list-table widefat' cellpadding='0' cellspacing='0'>
					<thead>					
						<tr class='alternate'>
							Tabla: <strong>".$tabla_valor."</strong>
						</tr>
						<tr class='alternate'>
							<th scope='col' id='cb' class='manage-column column-cb check-column '>
								<input type='checkbox' />
							</th>";
					
					for( $j = 0; $j < count( $nombre_columna ); $j++ ) {
						echo '<th><strong>'.$nombre_columna[$j]."</strong></th>";
					}
					echo "
						</tr>
					</thead>
					</tbody>";

					while ( $resultado = $execute->fetch_array() ) {
						echo "
						<tr class='alternate'>
							<th scope='row' class='check-column'>
								<input value='".$resultado[0]."' type='checkbox' name='data_id[]' />
							</th>\n";
						for ( $ind = 0; $ind < count( $resultado ) / 2; $ind++ ) {
							echo '<td class="id column-id">'.marcaTextos( $resultado[ $ind ] )."</td>";
						}	
						echo "</tr>\n";
					}
					echo "<tr>
							<td class='id column-id'>
								<input type='hidden' value='".$tabla_valor."' name='tbl_delete' />
								<input type='hidden' value='".$nombre_columna[0]."' name='col_delete' />";

					?>
								<input type='submit' class='button-primary' value='Delete' name='clean_data' onClick="return confirm('Really delete the selected rows?')" >
							</td>
						</tr>
					</tbody>
					</table>
					</form>
					<br>
					<?php
				}
				else {
					echo "<p>No results found: <strong>".$tabla_valor."</strong> >> <strong>".$parametro."</strong>.</p>";
				}
			}
		}
	}

	// Elimina registros
	if ( isset( $_POST['clean_data'] ) && $_GET['accion'] == "do" ) {
		$tbl =  htmlspecialchars( $_POST['tbl_delete'] );
		$tbl = $bdcleaner_conn->real_escape_string( $tbl );

		$col = htmlspecialchars( $_POST['col_delete'] );
		$col = $bdcleaner_conn->real_escape_string( $col );

		echo "<section><h3><a class='button-secondary' href='?page=bdcleaner-analisis'>Go Back</a></h3></section>
		<p>".count( $_POST['data_id'] )." entries was eliminated in table: <strong>".$tbl." </strong></p>\n";
		foreach ( $_POST['data_id'] as $id_delete ) {
			$query_delete = $bdcleaner_conn->query( "DELETE FROM `".DB_NAME."`.`".$tbl."` WHERE `".$tbl."`.`".$col."` =  ".$id_delete );
		}
	}
}
?>